/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SalesforceConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SalesforceConnectorForm{}

// SalesforceConnectorForm struct for SalesforceConnectorForm
type SalesforceConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Source label
	Label string `json:"label"`
	// OAuth ID
	OAuthId string `json:"oAuthId"`
	// Salesforce instance
	Instance string `json:"instance"`
	// Object to be queried
	Object string `json:"object"`
	// Salesforce API version
	ApiVersion string `json:"apiVersion"`
	// Salesforce filter
	Filter *string `json:"filter,omitempty"`
	// List of selected fields
	Attribute []string `json:"attribute"`
}

// NewSalesforceConnectorForm instantiates a new SalesforceConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSalesforceConnectorForm(connectorId string, templateId string, strategy string, label string, oAuthId string, instance string, object string, apiVersion string, attribute []string) *SalesforceConnectorForm {
	this := SalesforceConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.Label = label
	this.OAuthId = oAuthId
	this.Instance = instance
	this.Object = object
	this.ApiVersion = apiVersion
	this.Attribute = attribute
	return &this
}

// NewSalesforceConnectorFormWithDefaults instantiates a new SalesforceConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSalesforceConnectorFormWithDefaults() *SalesforceConnectorForm {
	this := SalesforceConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *SalesforceConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *SalesforceConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *SalesforceConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *SalesforceConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *SalesforceConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *SalesforceConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *SalesforceConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *SalesforceConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *SalesforceConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetLabel returns the Label field value
func (o *SalesforceConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *SalesforceConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetOAuthId returns the OAuthId field value
func (o *SalesforceConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *SalesforceConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetInstance returns the Instance field value
func (o *SalesforceConnectorForm) GetInstance() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Instance
}

// GetInstanceOk returns a tuple with the Instance field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetInstanceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Instance, true
}

// SetInstance sets field value
func (o *SalesforceConnectorForm) SetInstance(v string) {
	o.Instance = v
}

// GetObject returns the Object field value
func (o *SalesforceConnectorForm) GetObject() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Object
}

// GetObjectOk returns a tuple with the Object field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetObjectOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Object, true
}

// SetObject sets field value
func (o *SalesforceConnectorForm) SetObject(v string) {
	o.Object = v
}

// GetApiVersion returns the ApiVersion field value
func (o *SalesforceConnectorForm) GetApiVersion() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiVersion
}

// GetApiVersionOk returns a tuple with the ApiVersion field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetApiVersionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiVersion, true
}

// SetApiVersion sets field value
func (o *SalesforceConnectorForm) SetApiVersion(v string) {
	o.ApiVersion = v
}

// GetFilter returns the Filter field value if set, zero value otherwise.
func (o *SalesforceConnectorForm) GetFilter() string {
	if o == nil || IsNil(o.Filter) {
		var ret string
		return ret
	}
	return *o.Filter
}

// GetFilterOk returns a tuple with the Filter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetFilterOk() (*string, bool) {
	if o == nil || IsNil(o.Filter) {
		return nil, false
	}
	return o.Filter, true
}

// HasFilter returns a boolean if a field has been set.
func (o *SalesforceConnectorForm) HasFilter() bool {
	if o != nil && !IsNil(o.Filter) {
		return true
	}

	return false
}

// SetFilter gets a reference to the given string and assigns it to the Filter field.
func (o *SalesforceConnectorForm) SetFilter(v string) {
	o.Filter = &v
}

// GetAttribute returns the Attribute field value
func (o *SalesforceConnectorForm) GetAttribute() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value
// and a boolean to check if the value has been set.
func (o *SalesforceConnectorForm) GetAttributeOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Attribute, true
}

// SetAttribute sets field value
func (o *SalesforceConnectorForm) SetAttribute(v []string) {
	o.Attribute = v
}

func (o SalesforceConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SalesforceConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["label"] = o.Label
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["instance"] = o.Instance
	toSerialize["object"] = o.Object
	toSerialize["apiVersion"] = o.ApiVersion
	if !IsNil(o.Filter) {
		toSerialize["filter"] = o.Filter
	}
	toSerialize["attribute"] = o.Attribute
	return toSerialize, nil
}

type NullableSalesforceConnectorForm struct {
	value *SalesforceConnectorForm
	isSet bool
}

func (v NullableSalesforceConnectorForm) Get() *SalesforceConnectorForm {
	return v.value
}

func (v *NullableSalesforceConnectorForm) Set(val *SalesforceConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableSalesforceConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableSalesforceConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSalesforceConnectorForm(val *SalesforceConnectorForm) *NullableSalesforceConnectorForm {
	return &NullableSalesforceConnectorForm{value: val, isSet: true}
}

func (v NullableSalesforceConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSalesforceConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
